#include "interrupts.h"

//------------------------------------------------------------------------------
void interrupt myIsr(void) {
//..............................................................................
    //Timer1 overflow interrupt ~20ms
	if(PIE1bits.TMR1IE && PIR1bits.TMR1IF) {
        main_sm.t1_ovf = 1;
        PIR1bits.TMR1IF = 0; //clear interrupt flag
	}
//..............................................................................
	//Timer2 overflow
    if(PIE1bits.TMR2IE && PIR1bits.TMR2IF) {
        PORTC = ~(ds.disp_buf & ds.segment_selector);
        ds.segment_selector <<= 1;
        ds.segment_slot_counter++;
        PIR1bits.TMR2IF = 0;
    }
//..............................................................................
	//External interrupt 
//	if(INTCONbits.INTE && INTCONbits.INTF) {
//        tpulse = TMR0;
//        TMR0 = 0;
//        tpulse_ready = 1;
//        //change triggering edge 
//		if (OPTION_REGbits.INTEDG) {
//            OPTION_REGbits.INTEDG = 0; //0: falling
//		} else {
//            OPTION_REGbits.INTEDG = 1;
//        }

//		INTCONbits.INTF = 0;
//	}
//..............................................................................    
    //Pin RA2 change interrupt 
    if(INTCONbits.RABIE && INTCONbits.RABIF) {
        main_sm.tpulse = TMR0;
        TMR0 = 0;
        main_sm.ir_pulse_received = 1;
        PORTA = PORTA;
        INTCONbits.RABIF = 0;
    }
//..............................................................................
	//Timer0 overflow 16384ms
    if(INTCONbits.T0IE && INTCONbits.T0IF) {
        main_sm.tpulse = T_OVERTIME;
        main_sm.ir_pulse_received = 1;
        INTCONbits.T0IF = 0;
    }
   
//..............................................................................	    
}
//------------------------------------------------------------------------------